/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
import { ISupportsExpansionChangeNotifications_$type } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
export let LocalDataSource = /*@__PURE__*/ (() => {
    class LocalDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cb = null;
            this.ca = null;
            this.da = null;
            this.cg = null;
            this.ck = null;
            this.cm = null;
            this.ci = null;
            this.cw = new List$1(Array_$type, 0);
            this.cn = false;
            this.b9 = null;
            this.c4 = -1;
            this.cx = -1;
            this.c6 = -1;
            this.cz = -1;
            this.c7 = -1;
            this.c0 = -1;
            this.c5 = -1;
            this.cy = -1;
            this.c9 = -1;
            this.c8 = -1;
            this.c2 = -1;
            this.c1 = -1;
            this.c3 = -1;
            this.executionContext = new DataSourceExecutionContext();
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cb;
        }
        set dataProvider(a) {
            let b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.onPropertyUpdated("DataProvider", b, this.cb);
            }
        }
        get actualDataProvider() {
            if (this.ca == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.ca;
        }
        set actualDataProvider(a) {
            let b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.onPropertyUpdated("ActualDataProvider", b, this.ca);
            }
        }
        get itemsSource() {
            return this.da;
        }
        set itemsSource(a) {
            let b = this.da;
            this.da = a;
            if (b != this.da) {
                this.onPropertyUpdated("ItemsSource", b, this.da);
            }
        }
        canInitialize() {
            let a = super.canInitialize();
            if (!a) {
                return false;
            }
            return this.itemsSource != null;
        }
        get ch() {
            return this.cg;
        }
        set ch(a) {
            this.cg = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            let provider_ = new DataSourceLocalDataProvider();
            provider_.executionContext = new DataSourceExecutionContext();
            return provider_;
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    break;
                case "ActualDataProvider":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.itemsSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
                case "ItemsSource":
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.dataSource = this.itemsSource;
                        this.actualSchema = this.actualDataProvider.actualSchema;
                        this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                    }
                    this.queueAutoRefresh();
                    break;
            }
        }
        getItemAtIndex(a) {
            if (this.ck != null && this.ck.av != null) {
                return this.ck.av.item(a);
            }
            else {
                return this.actualDataProvider.getItemAtIndex(a);
            }
        }
        getItemPropertyAtIndex(a, b) {
            let c;
            if (this.ck != null) {
                c = this.ck.av.item(a);
            }
            else {
                c = this.actualDataProvider.getItemAtIndex(a);
            }
            let item_ = c;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return this.getSpecialRowItemValue(c, b);
            }
            return this.actualDataProvider.getItemValue(c, b);
        }
        cf() {
            return this.actualDataProvider;
        }
        cp() {
            return this.cw != null && this.cw.count > 0;
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            if (this.actualDataProvider != null) {
                if (this.cq() || this.cr() || this.cs() || this.ct() || this.cp()) {
                    if (this.ck == null) {
                        if (this.cm == null) {
                            this.cm = new LocalDataSourceViewUpdateNotifier(this);
                        }
                        this.ck = new RearrangedListView(this.actualDataProvider);
                        this.ck.v = this.cm;
                        this.ck.x = new LocalDataSourceViewExpansionNotifier(this);
                    }
                    this.ensureComparables(this.actualDataProvider.actualSchema);
                    this.ck.ak = this.shouldEmitSectionHeaders && this.ah;
                    this.ck.aj = this.shouldEmitSectionFooters && this.ah;
                    this.ck.al = this.shouldEmitShiftedRows;
                    this.ck.bs(this.cw);
                    this.ck.ar = this.cv();
                    this.ck.aq = this.cu();
                    this.ck.k = this.cj();
                    this.ck.y = this.groupDescriptions;
                    this.ck.z = this.sortDescriptions;
                    this.ck.aa = this.summaryDescriptions;
                    this.ck.g = this.summaryScope;
                    this.ck.h = this;
                    this.ck.ag = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                    this.ck.o = this.cl();
                    this.ck.bo();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.ck.av.count;
                }
                else {
                    let a = this.cf();
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    if (a != null) {
                        this.actualCount = a.actualCount;
                    }
                    else {
                        this.actualCount = 0;
                    }
                    if (this.ck != null) {
                        this.ck.v = null;
                        this.ck = null;
                        this.onBroadcastClearItems();
                    }
                }
            }
            else {
                this.actualCount = 0;
                this.actualSchema = null;
            }
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            if (this.ck != null) {
                return this.ck.av.indexOf(a);
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            if (this.actualDataProvider != null) {
                let b = this.actualDataProvider.actualCount;
                let c;
                for (let d = 0; d < b; d++) {
                    c = this.actualDataProvider.getItemAtIndex(d);
                    if (this.co(c, a)) {
                        return d;
                    }
                }
            }
            return -1;
        }
        co(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return this.indexOfItem(a[0]);
            }
            let c = this.cj();
            let d;
            if (this.ck != null) {
                let e = this.ck.av.count;
                for (let f = 0; f < e; f++) {
                    d = this.ck.av.item(f);
                    if (!(typeCast(DataSourceSpecialRow.$, d) !== null) && c.i(d, a) == 0) {
                        return f;
                    }
                }
                return -1;
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            if (this.actualDataProvider != null) {
                let g = this.actualDataProvider.actualCount;
                for (let h = 0; h < g; h++) {
                    d = this.actualDataProvider.getItemAtIndex(h);
                    if (c.i(d, a) == 0) {
                        return h;
                    }
                }
            }
            return -1;
        }
        onActualPrimaryKeyChangedOverrride(a, b) {
            super.onActualPrimaryKeyChangedOverrride(a, b);
            this.ci = null;
        }
        cj() {
            if (this.ci != null) {
                return this.ci;
            }
            if (this.actualPrimaryKey == null) {
                this.ci = new DataSourcePropertiesComparer(null, null, null, this);
                return this.ci;
            }
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            this.ci = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
            return this.ci;
        }
        cl() {
            if (this.filterExpressions.j.count == 0) {
                return null;
            }
            let a = this.actualDataProvider;
            let b = this.actualDataProvider.actualSchema;
            let c = this.filterExpressions.j;
            let d = (e) => {
                for (let f = 0; f < c.count; f++) {
                    if (!c.item(f).match(e, a, b)) {
                        return false;
                    }
                }
                return true;
            };
            return d;
        }
        cv() {
            let a = 0;
            if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
                return null;
            }
            a = this.sortDescriptions.k.count;
            if (this.groupDescriptions != null) {
                a += this.groupDescriptions.k.count;
            }
            let b = new Array(a);
            let c = new Array(a);
            let d = 0;
            if (this.groupDescriptions != null) {
                for (let e = 0; e < this.groupDescriptions.k.count; e++) {
                    b[e] = this.groupDescriptions.k.item(e).propertyName;
                    c[e] = this.groupDescriptions.k.item(e).direction;
                    d++;
                }
            }
            for (let f = 0; f < this.sortDescriptions.k.count; f++) {
                b[f + d] = this.sortDescriptions.k.item(f).propertyName;
                c[f + d] = this.sortDescriptions.k.item(f).direction;
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        cu() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return null;
            }
            let a = 0;
            a = this.groupDescriptions.k.count;
            let b = new Array(a);
            let c = new Array(a);
            if (this.groupDescriptions != null) {
                for (let d = 0; d < this.groupDescriptions.k.count; d++) {
                    b[d] = this.groupDescriptions.k.item(d).propertyName;
                    c[d] = this.groupDescriptions.k.item(d).direction;
                }
            }
            return new DataSourcePropertiesComparer(b, c, this.d, this);
        }
        cr() {
            if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isGroupingSupported) {
                return false;
            }
            return true;
        }
        cs() {
            if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
                return false;
            }
            if (this.actualDataProvider == null) {
                return false;
            }
            if (this.actualDataProvider.isSortingSupported) {
                return false;
            }
            return true;
        }
        cq() {
            return this.filterExpressions != null && this.filterExpressions.j.count > 0;
        }
        ct() {
            if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
                return false;
            }
            return true;
        }
        onClearItemsOverride() {
            if (this.ck != null) {
                this.ck.notifyClearItems();
                this.queueAutoRefresh();
            }
            else {
                super.onClearItemsOverride();
            }
        }
        onSetItemOverride(a, b, c) {
            if (this.ck != null) {
                this.ck.notifySetItem(a, b, c);
            }
            else {
                super.onSetItemOverride(a, b, c);
            }
        }
        onInsertItemOverride(a, b) {
            if (this.ck != null) {
                this.ck.notifyInsertItem(a, b);
            }
            else {
                super.onInsertItemOverride(a, b);
            }
        }
        onRemoveItemOverride(a, b) {
            if (this.ck != null) {
                this.ck.notifyRemoveItem(a, b);
            }
            else {
                super.onRemoveItemOverride(a, b);
            }
        }
        df() {
            this.actualCount = this.ck.av.count;
            this.onBroadcastClearItems();
        }
        di(a, b, c) {
            this.actualCount = this.ck.av.count;
            this.onBroadcastSetItem(a, b, c);
        }
        dg(a, b) {
            this.actualCount = this.ck.av.count;
            this.onBroadcastInsertItem(a, b);
        }
        dh(a, b) {
            this.actualCount = this.ck.av.count;
            this.onBroadcastRemoveItem(a, b);
        }
        pinRow(a) {
            super.pinRow(a);
            this.c4 = -1;
            this.cx = -1;
            if (this.ck != null) {
                this.cw.add(a);
                this.ck.bn(a);
            }
            else {
                this.cw.add(a);
                this.queueAutoRefresh();
            }
        }
        unpinRow(a) {
            super.unpinRow(a);
            let b = this.cj();
            if (this.ck != null) {
                for (let c = this.cw.count - 1; c >= 0; c--) {
                    let d = this.cw._inner[c];
                    if (d.length != a.length) {
                        continue;
                    }
                    if (b.h(d, a) == 0) {
                        this.cw.removeAt(c);
                        this.ck.bu(d);
                    }
                }
            }
            else {
                for (let e = this.cw.count - 1; e >= 0; e--) {
                    let f = this.cw._inner[e];
                    if (f.length != a.length) {
                        continue;
                    }
                    if (b.h(f, a) == 0) {
                        this.cw.removeAt(e);
                    }
                }
                this.queueAutoRefresh();
            }
            this.c4 = -1;
            this.cx = -1;
        }
        clearPinnedRows() {
            for (let a = this.cw.count - 1; a >= 0; a--) {
                this.unpinRow(this.cw._inner[a]);
            }
        }
        isRowPinned(a) {
            if (this.ck == null) {
                return false;
            }
            let b = this.getItemAtIndex(a);
            if (b == null) {
                return false;
            }
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                if (item_.rowType == 3) {
                    return true;
                }
            }
            let c = this.cj();
            let d;
            if (this.actualPrimaryKey == null) {
                d = new Array(1);
                d[0] = b;
            }
            else {
                let e = this.actualPrimaryKey;
                let f = e.length;
                d = new Array(f);
                for (let g = 0; g < f; g++) {
                    d[g] = this.getItemProperty(b, e[g]);
                }
            }
            for (let h = 0; h < this.cw.count; h++) {
                if (c.h(this.cw._inner[h], d) == 0) {
                    return true;
                }
            }
            return false;
        }
        get_isSortingSupported() {
            if (this.o != null && !this.cn) {
                this.cn = true;
                let a = this.o.isSortingSupportedOverride;
                this.cn = false;
                return a;
            }
            return true;
        }
        get_isFilteringSupported() {
            if (this.o != null && !this.cn) {
                this.cn = true;
                let a = this.o.isFilteringSupportedOverride;
                this.cn = false;
                return a;
            }
            return true;
        }
        get_isGroupingSupported() {
            if (this.o != null && !this.cn) {
                this.cn = true;
                let a = this.o.isGroupingSupportedOverride;
                this.cn = false;
                return a;
            }
            return true;
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        getStickyRowsInRange(a, b) {
            if (this.ck == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.cp())) {
                return null;
            }
            let c = null;
            let d = null;
            if (this.ck.au.count == 1) {
                c = this.ck.au._inner[0];
                d = this.ck.au._inner[0];
            }
            else {
                c = this.ck.r(a);
                d = this.ck.r(b);
                if (b >= this.ck.av.count - this.ck.a6) {
                    d = this.ck.q();
                }
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.q == this.c4 && c.l == this.c6 && c.r == this.c7 && c.p == this.c5 && c.t == this.c9 && c.s == this.c8 && d.q == this.cx && d.l == this.cz && d.r == this.c0 && d.p == this.cy && d.t == this.c2 && d.s == this.c1 && this.ck.a6 == this.c3) {
                return this.b9;
            }
            this.c4 = c.q;
            this.cx = d.q;
            this.c6 = c.l;
            this.cz = d.l;
            this.c7 = c.r;
            this.c0 = d.r;
            this.c5 = c.p;
            this.cy = d.p;
            this.c3 = this.ck.a6;
            if (this.ck.au.count == 1) {
                this.cx = d.p;
            }
            let e = 0;
            if (this.shouldEmitSectionHeaders && this.ah) {
                e = 1;
            }
            let f = new List$1(Number_$type, 0);
            for (let g = c.q; g <= d.q; g++) {
                let h = this.ck.au._inner[g].b.length;
                if (this.shouldEmitSectionHeaders && this.ah) {
                    for (let i = 0; i < h; i++) {
                        f.add(this.ck.au._inner[g].r + i);
                        if (!this.ck.au._inner[g].b[i]) {
                            break;
                        }
                    }
                }
                if (this.ck.au._inner[g].g) {
                    for (let j = 0; j < this.ck.au._inner[g].t; j++) {
                        f.add(this.ck.au._inner[g].r + j + h);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let k = 0; k < this.ck.au._inner[g].l; k++) {
                            f.add(this.ck.au._inner[g].r + this.ck.au._inner[g].t + k + h);
                        }
                    }
                    for (let l = this.ck.au._inner[g].s - 1; l >= 0; l--) {
                        if (this.shouldEmitSectionFooters) {
                            f.add(this.ck.au._inner[g].p - h - l);
                        }
                        else {
                            f.add(this.ck.au._inner[g].p - l);
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.ah) {
                    for (let m = h - 1; m >= 0; m--) {
                        if (!this.ck.au._inner[g].b[m]) {
                            break;
                        }
                        f.add(this.ck.au._inner[g].p - m);
                    }
                }
            }
            for (let n = this.ck.av.count - this.ck.a6; n < this.ck.av.count; n++) {
                f.add(n);
            }
            this.b9 = f.toArray();
            return this.b9;
        }
        isExclusivelySticky(a) {
            let b = this.getRowType(a);
            return b == 1 || b == 2 || b == 4 || b == 5;
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.rowType;
            }
            return 0;
        }
        setIsRowExpandedAtIndex(a, b) {
            if (this.isSectionCollapsable && this.ck != null && this.ck.av.count > 0 && this.ck.av.count > a) {
                this.ck.br(a, b);
            }
        }
        getIsRowExpandedAtIndex(a) {
            if (this.ck != null && this.ck.av.count > 0 && this.ck.av.count > a) {
                return this.ck.ae(a);
            }
            return true;
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            if (this.ck != null) {
                return this.ck.a6;
            }
            return 0;
        }
        getRootSummaryResults() {
            if (this.ck != null) {
                return this.ck.e;
            }
            return null;
        }
        getSectionSummaryResults(a) {
            if (this.ck != null && this.ck.au.count > 0 && a >= 0 && a < this.ck.au.count) {
                return this.ck.au._inner[a].e;
            }
            return null;
        }
    }
    LocalDataSource.$t = /*@__PURE__*/ markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewUpdateNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewUpdateNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyClearItems() {
            this.a.df();
        }
        notifyInsertItem(a, b) {
            this.a.dg(a, b);
        }
        notifyRemoveItem(a, b) {
            this.a.dh(a, b);
        }
        notifySetItem(a, b, c) {
            this.a.di(a, b, c);
        }
    }
    LocalDataSourceViewUpdateNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
})();
/**
 * @hidden
 */
export let LocalDataSourceViewExpansionNotifier = /*@__PURE__*/ (() => {
    class LocalDataSourceViewExpansionNotifier extends Base {
        constructor(a) {
            super();
            this.a = null;
            this.a = a;
        }
        notifyRowExpansionChanged(a, b, c) {
            this.a.onRowExpansionChanged(a, b, c);
        }
    }
    LocalDataSourceViewExpansionNotifier.$t = /*@__PURE__*/ markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
})();
//# sourceMappingURL=LocalDataSource_combined.js.map
