/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
export let VirtualDataSource = /*@__PURE__*/ (() => {
    class VirtualDataSource extends BaseDataSource {
        constructor() {
            super();
            this.cb = null;
            this.cs = false;
            this.de = 0;
            this.cm = null;
            this.cf = null;
            this.ce = null;
            this.dd = 50;
            this.dc = 200;
            this.actualPageSizePopulated = false;
            this.cy = 50;
            this.cq = false;
            this.cj = null;
            this.cp = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
            this.cw = new Dictionary$2(Base.$, Array_$type, 0);
            this.cx = new Dictionary$2(Number_$type, Number_$type, 0);
            this.cr = false;
            this.b9 = null;
            this.cc = null;
            this.co = new SectionMap();
            this.ca = null;
            this.c6 = -1;
            this.cz = -1;
            this.c8 = -1;
            this.c1 = -1;
            this.c9 = -1;
            this.c2 = -1;
            this.c7 = -1;
            this.c0 = -1;
            this.db = -1;
            this.da = -1;
            this.c4 = -1;
            this.c3 = -1;
            this.c5 = -1;
            this.cv = new Dictionary$2(String_$type, Boolean_$type, 0);
            this.cm = new PagePredictionEngine();
            this.cm.e = this;
            this.cm.ag = this.actualPageSize;
            this.cm.f = this.co;
            this.executionContext = new DataSourceExecutionContext();
            this.cm.b = this.executionContext;
        }
        get_actualBaseDataProvider() {
            return this.actualDataProvider;
        }
        get actualBaseDataProvider() {
            return this.get_actualBaseDataProvider();
        }
        get dataProvider() {
            return this.cf;
        }
        set dataProvider(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.onPropertyUpdated("DataProvider", b, this.cf);
            }
        }
        get actualDataProvider() {
            if (this.ce == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.ce;
        }
        set actualDataProvider(a) {
            let b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.onPropertyUpdated("ActualDataProvider", b, this.ce);
            }
        }
        get pageSizeRequested() {
            return this.dd;
        }
        set pageSizeRequested(a) {
            let b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.onPropertyUpdated("PageSizeRequested", b, this.dd);
            }
        }
        resetCache() {
            if (this.ck != null) {
                this.ck.resetCache();
            }
            this.resetCacheOverride();
        }
        resetCacheOverride() {
            this.cp.i();
        }
        get maxCachedPages() {
            return this.dc;
        }
        set maxCachedPages(a) {
            let b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.onPropertyUpdated("MaxCachedPages", b, this.dc);
            }
        }
        get actualPageSize() {
            return this.cy;
        }
        set actualPageSize(a) {
            let b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.onPropertyUpdated("ActualPageSize", b, this.cy);
            }
        }
        get_isSortingSupported() {
            if (this.o != null && !this.cq) {
                this.cq = true;
                let a = this.o.isSortingSupportedOverride;
                this.cq = false;
                return a;
            }
            return false;
        }
        get_isFilteringSupported() {
            if (this.o != null && !this.cq) {
                this.cq = true;
                let a = this.o.isFilteringSupportedOverride;
                this.cq = false;
                return a;
            }
            return false;
        }
        get_isGroupingSupported() {
            if (this.o != null && !this.cq) {
                this.cq = true;
                let a = this.o.isGroupingSupportedOverride;
                this.cq = false;
                return a;
            }
            return false;
        }
        get ck() {
            return this.cj;
        }
        set ck(a) {
            this.cj = a;
            this.actualDataProvider = this.resolveDataProvider();
        }
        resolveDataProvider() {
            if (this.ck == null) {
                return null;
            }
            return this.ck.resolveDataProvider();
        }
        propertyUpdatedOverride(a, b, c) {
            super.propertyUpdatedOverride(a, b, c);
            switch (a) {
                case "DataProvider":
                    this.actualDataProvider = this.dataProvider;
                    this.queueAutoRefresh();
                    break;
                case "ExecutionContext":
                    this.cm.b = this.executionContext;
                    break;
                case "ActualDataProvider":
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    this.actualDataProvider.pageLoaded = runOn(this, this.dv);
                    this.queueAutoRefresh();
                    break;
                case "PageSizeRequested":
                    this.actualPageSize = this.pageSizeRequested;
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                    }
                    this.queueAutoRefresh();
                    break;
                case "ActualPageSize":
                    this.cm.ag = this.actualPageSize;
                    this.queueAutoRefresh();
                    break;
                case "FirstVisibleIndexRequested":
                    this.cm.aa = this.firstVisibleIndexRequested;
                    break;
                case "LastVisibleIndexRequested":
                    this.cm.ae = this.lastVisibleIndexRequested;
                    break;
                case "ActualCount":
                    if (this.actualDataProvider != null && !this.co.n) {
                        this.cm.ab = this.actualDataProvider.actualCount;
                    }
                    else {
                        this.cm.ab = this.actualCount;
                    }
                    this.queueAutoRefresh();
                    break;
                case "MaxCachedPages":
                    this.cp.h = this.maxCachedPages;
                    break;
            }
        }
        dh(a) {
            if (this.ah && this.co.n) {
                let b = this.cn(a);
                if (b == null) {
                    b = this.co.c();
                }
                return a - b.i;
            }
            return a;
        }
        dv(a, b, c) {
            let d = this.executionContext;
            if (d != null) {
                d.execute(() => this.d1(a, b, c));
            }
            else {
                this.d1(a, b, c);
            }
        }
        d1(a, b, c) {
            if (a == null) {
                b = this.resolveFullCount(b);
                if (this.actualCount != b) {
                    this.actualCount = b;
                }
                return;
            }
            if (c != this.actualPageSize && !this.actualPageSizePopulated) {
                this.actualPageSize = c;
            }
            this.actualPageSizePopulated = true;
            let d = a.pageIndex();
            this.dw(d);
            this.cp.item(d, a);
            let e = a.schema();
            if (e != null) {
                this.actualSchema = e;
            }
            let f = a.getSummaryInformation();
            if (this.cc == null && f != null) {
                this.cc = f;
                for (let g = 0; g < this.summaryDescriptions.k.count; g++) {
                    this.cc[g].summaryIndex = g;
                }
                let h = SectionData.h(this.cc);
                this.de = h.count;
            }
            let i = a.getGroupInformation();
            if (this.b9 == null && i != null) {
                this.b9 = i;
                this.d0();
                this.cs = false;
            }
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            this.dz(a);
        }
        resolveFullCount(a) {
            if (this.b9 != null) {
                return this.co.q + this.de;
            }
            return a + this.de;
        }
        d0() {
            let a = 0;
            let b = 0;
            let c = 0;
            if (this.shouldEmitSectionHeaders) {
                switch (this.sectionHeaderDisplayMode) {
                    case 0:
                        c++;
                        break;
                    case 1:
                        c += this.groupDescriptions.k.count;
                        break;
                }
            }
            if (this.shouldEmitSectionFooters) {
                c++;
            }
            let d = this.shouldEmitSectionHeaders;
            let e = this.shouldEmitSectionFooters;
            for (let f = 0; f < this.b9.length; f++) {
                let g = new SectionData();
                if (d) {
                    switch (this.sectionHeaderDisplayMode) {
                        case 0:
                            b++;
                            break;
                        case 1:
                            b += this.groupDescriptions.k.count;
                            break;
                    }
                }
                let h = this.b9[f].endIndex - this.b9[f].startIndex;
                g.r = a;
                g.q = f;
                g.o = h + 1;
                g.p = a + h;
                g.p += c;
                g.i = b;
                g.c = this.b9[f].groupKeyProperties;
                g.d = this.b9[f].groupKeyValues;
                g.u(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
                if (e) {
                    g.j = g.b.length;
                }
                let i = 0;
                g.e = this.b9[f].summaryResults;
                if (g.e != null) {
                    for (let j = 0; j < g.e.length; j++) {
                        g.e[j].summaryIndex = j;
                    }
                    i = SectionData.h(g.e).count;
                }
                if (this.includeSummaryRowsInSection) {
                    if (this.isSectionSummaryRowsAtBottom) {
                        g.s = i;
                    }
                    else {
                        g.t = i;
                        g.i += i;
                    }
                    b += i;
                    g.p += i;
                }
                if (e) {
                    b++;
                }
                for (let k = 0; k < g.b.length; k++) {
                    let l = this.dr(g, k);
                    g.a[k] = l;
                    if (this.cv.containsKey(l)) {
                        g.b[k] = this.cv.item(l);
                    }
                    else {
                        g.b[k] = this.isSectionExpandedDefault;
                    }
                    if (!g.b[k]) {
                        let m = g.b.length - 1 - k;
                        g.p -= m;
                        b -= m;
                        if (e) {
                            b--;
                            g.j--;
                        }
                        k += m;
                    }
                }
                if (!g.g) {
                    g.p -= g.o + i;
                    b -= g.o + i;
                }
                a = g.p + 1;
                this.co.p.add(g);
            }
        }
        dz(a) {
            if (this.updateNotifier != null) {
                let b = a.pageIndex() * this.actualPageSize;
                if (this.actualDataProvider != null) {
                    if (b > this.actualDataProvider.actualCount) {
                        return;
                    }
                }
                let c = this.dg(b);
                let d = this.dg(b + a.count() - 1);
                if (c > 0 && this.getRowType(c - 1) == 1) {
                    c--;
                }
                if (this.actualCount == 0 && a.count() == 0) {
                    this.onClearItems();
                }
                else {
                    this.updateNotifier.rangeActualized(c, d);
                }
            }
        }
        dg(a) {
            if (this.ah && this.co.n) {
                let b = this.co.f(a);
                if (b == null) {
                    b = this.co.c();
                }
                if (!b.g) {
                    return b.r;
                }
                return a + b.i;
            }
            return a;
        }
        dx(a) {
            a();
        }
        get_isVirtual() {
            return true;
        }
        isPlaceholderItem(a) {
            let b = this.cd(a);
            let c = b[0];
            if (!this.cp.d(c)) {
                if (b[1] == -1) {
                    return false;
                }
                return true;
            }
            return false;
        }
        getItemAtIndex(a) {
            if (a >= this.actualCount - this.de) {
                return this.dl(a);
            }
            let b = this.cd(a);
            let c = b[0];
            if (!this.cp.d(c)) {
                if (b[1] == -1) {
                    return this.dl(a);
                }
                return null;
            }
            let d = this.cp.item(c);
            let e = b[1];
            if (e == -1) {
                return this.dl(a);
            }
            return d.getItemAtIndex(e);
        }
        dl(a) {
            if (a >= this.actualCount - this.de) {
                let b = new DataSourceSpecialRow();
                b.rowType = 4;
                b.level = 0;
                let c = a - (this.actualCount - this.de);
                let d = SectionData.h(this.cc);
                let e = new Array(d._inner[c].count);
                d._inner[c].values.copyTo(e, 0);
                b.summaryResults = e;
                return b;
            }
            let f = this.cn(a);
            if (f != null) {
                let g = f.f(a);
                if (g == 1 || g == 2) {
                    let h = new DataSourceSpecialRow();
                    h.rowType = g;
                    h.summaryResults = f.e;
                    for (let i = 0; i < this.groupDescriptions.k.count; i++) {
                        h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.d[i]);
                        h.setValue(this.groupDescriptions.k.item(i).propertyName, f.d[i]);
                    }
                    h.level = g == 1 ? a - f.r : (f.j - 1) - (a - (f.p - f.j + 1));
                    return h;
                }
                else if (g == 5) {
                    let j = new DataSourceSpecialRow();
                    j.rowType = 5;
                    j.level = f.b.length;
                    let k = f.k(a);
                    let l = SectionData.h(f.e);
                    let m = new Array(l._inner[k].count);
                    l._inner[k].values.copyTo(m, 0);
                    j.summaryResults = m;
                    return j;
                }
            }
            return null;
        }
        cd(a) {
            if (this.ah && this.co.n) {
                let b = false;
                let c = this.cn(a);
                if (c == null) {
                    c = this.co.c();
                    if (this.cc.length > 0 && a > c.p) {
                        b = true;
                    }
                }
                let d = c.r;
                if (a >= d && a < d + c.b.length && this.shouldEmitSectionHeaders) {
                    b = true;
                }
                if (a - (d + c.b.length - 1) <= c.l + c.t) {
                    b = true;
                }
                if (this.shouldEmitSectionFooters) {
                    if (a <= c.p && a >= c.p - c.b.length - c.s) {
                        b = true;
                    }
                }
                else if (c.s > 0) {
                    if (a > c.p - c.s && a <= c.p) {
                        b = true;
                    }
                }
                let e = a - c.i;
                let f = truncate(Math.floor(e / this.actualPageSize));
                let g = e % this.actualPageSize;
                if (b) {
                    g = -1;
                }
                let h = new Array(2);
                h[0] = f;
                h[1] = g;
                return h;
            }
            else {
                let i = truncate(Math.floor(a / this.actualPageSize));
                let j = a % this.actualPageSize;
                let k = new Array(2);
                k[0] = i;
                k[1] = j;
                return k;
            }
        }
        cn(a) {
            return this.co.d(a);
        }
        getItemPropertyAtIndex(a, b) {
            if (a > (this.actualCount - 1) - this.de) {
                return this.dm(a, b);
            }
            let c = this.cd(a);
            let d = c[0];
            if (!this.cp.d(d)) {
                if (c[1] == -1) {
                    return this.dm(a, b);
                }
                return null;
            }
            let e = this.cp.item(d);
            let f = c[1];
            if (f == -1) {
                return this.dm(a, b);
            }
            return e.getItemValueAtIndex(f, b);
        }
        dm(a, b) {
            let c = this.dl(a);
            if (typeCast(DataSourceSpecialRow.$, c) !== null) {
                return c.getValue(b);
            }
            return null;
        }
        dy(a) {
            if (!this.cx.containsKey(a)) {
                this.cx.addItem(a, 1);
            }
            else {
                this.cx.item(a, this.cx.item(a) + 1);
            }
        }
        dw(a) {
            if (this.cx.containsKey(a)) {
                this.cx.item(a, this.cx.item(a) - 1);
                if (this.cx.item(a) <= 0) {
                    this.cx.removeItem(a);
                    if (this.actualDataProvider != null) {
                        this.actualDataProvider.removePageRequest(a);
                    }
                }
            }
        }
        addCandidate(a, b) {
            let c = false;
            if (!this.cw.containsKey(a)) {
                let d = new List$1(Number_$type, 0);
                let e = this.transformPage(a);
                for (let f = 0; f < e.length; f++) {
                    let g = e[f];
                    if (!this.cp.d(g)) {
                        d.add(g);
                        this.dy(g);
                        let h = this.cx.item(g);
                        if (h == 1 && this.actualDataProvider != null) {
                            this.actualDataProvider.addPageRequest(g, b);
                        }
                        c = true;
                    }
                }
                if (d.count > 0) {
                    this.cw.addItem(a, d.toArray());
                }
            }
            return c;
        }
        removeCandidate(a) {
            if (this.cw.containsKey(a)) {
                for (let b = 0; b < this.cw.item(a).length; b++) {
                    let c = this.cw.item(a)[b];
                    this.dw(c);
                }
                this.cw.removeItem(a);
            }
        }
        transformPage(a) {
            let b = [a];
            if (this.ah && this.co.n) {
                let c = a * this.actualPageSize;
                let d = c + this.actualPageSize - 1;
                let e = this.cn(c);
                let f = new List$1(Number_$type, 0);
                for (let g = c; g <= d; g++) {
                    if (e == null) {
                        break;
                    }
                    if (g > e.p) {
                        if (e.q < this.co.p.count - 1) {
                            e = this.co.p._inner[e.q + 1];
                        }
                        else {
                            break;
                        }
                    }
                    if (!e.g || (g >= e.r && g <= e.r + (e.b.length - 1) + e.l)) {
                        continue;
                    }
                    let h = g - e.i;
                    let i = intDivide(h, this.actualPageSize);
                    if (!f.contains(i)) {
                        f.add(i);
                    }
                }
                b = f.toArray();
            }
            return b;
        }
        getUnrealizedCount() {
            let a = this.cp.g * this.actualPageSize;
            let b = this.actualCount - a;
            return b;
        }
        onSetItemOverride(a, b, c) {
            super.onSetItemOverride(a, b, c);
            let d = this.cd(a);
            let e = d[0];
            if (this.cp.d(e)) {
                this.cp.j(e);
            }
        }
        refreshInternalOverride() {
            super.refreshInternalOverride();
            this.actualPageSizePopulated = false;
            let a = this.actualCount != 0;
            this.cr = true;
            if (!this.cs) {
                this.resetCache();
                if (a) {
                    this.onClearItems();
                }
                this.b9 = null;
                this.cc = null;
                this.de = 0;
                this.co.r();
            }
            else {
                this.cs = false;
                if (a) {
                    this.onClearItems();
                }
            }
            this.d2();
            this.cm.au();
            this.cr = false;
        }
        d2() {
            if (this.actualDataProvider != null) {
                for (let a of fromEnum(this.cw.values)) {
                    for (let c = 0; c < a.length; c++) {
                        let b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
        }
        onClearItemsOverride() {
            super.onClearItemsOverride();
            if (!this.cr) {
                this.queueAutoRefresh();
            }
        }
        onInsertItemOverride(a, b) {
            super.onInsertItemOverride(a, b);
            this.queueAutoRefresh();
        }
        onRemoveItemOverride(a, b) {
            super.onRemoveItemOverride(a, b);
            this.queueAutoRefresh();
        }
        get_isItemIndexLookupSupported() {
            return true;
        }
        get_isKeyIndexLookupSupported() {
            return true;
        }
        indexOfItem(a) {
            let b = this.cp.b;
            let c = b.o;
            let d = b.q;
            let e = d.count;
            let f = b.p;
            for (let g = 0; g < e; g++) {
                if (f._inner[g]) {
                    continue;
                }
                let h = d._inner[g].b;
                let i = h.count();
                for (let j = 0; j < i; j++) {
                    if (this.cu(h.getItemAtIndex(j), a)) {
                        let k = typeGetValue(c._inner[g]);
                        let l = k * this.actualPageSize;
                        return l + j;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
                return this.actualDataProvider.indexOfItem(a);
            }
            return -1;
        }
        cu(a, b) {
            if (a == null && b == null) {
                return true;
            }
            if (a == null || b == null) {
                return false;
            }
            return Base.equalsStatic(a, b);
        }
        indexOfKey(a) {
            let b = this.actualPrimaryKey;
            if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
                return -1;
            }
            this.ensureComparables(this.actualSchema);
            let c = this.cl();
            let d = this.cp.b;
            let e = d.o;
            let f = d.q;
            let g = f.count;
            let h = d.p;
            for (let i = 0; i < g; i++) {
                if (h._inner[i]) {
                    continue;
                }
                let j = f._inner[i].b;
                let k = j.count();
                for (let l = 0; l < k; l++) {
                    if (c.i(j.getItemAtIndex(l), a) == 0) {
                        let m = typeGetValue(e._inner[i]);
                        let n = m * this.actualPageSize;
                        return n + l;
                    }
                }
            }
            if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
                return this.actualDataProvider.indexOfKey(a);
            }
            return -1;
        }
        cl() {
            let a = new Array(this.actualPrimaryKey.length);
            for (let b = 0; b < a.length; b++) {
                a[b] = 0;
            }
            return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.cb, this);
        }
        getStickyRowPriority(a) {
            let b = this.getRowType(a);
            switch (b) {
                case 1: return 100 - this.getRowLevel(a);
                case 2: return 99 - this.getRowLevel(a);
                case 3:
                case 5: return 2;
                case 4: return 3;
            }
            return 1;
        }
        unpinRow(a) {
            super.unpinRow(a);
        }
        pinRow(a) {
            super.pinRow(a);
        }
        isRowPinned(a) {
            return super.isRowPinned(a);
        }
        getStickyRowsInRange(a, b) {
            if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
                return null;
            }
            let c = this.cn(a);
            let d = this.cn(b);
            if (this.co.p.count > 0) {
                if (this.co.p.count == 1) {
                    c = this.co.p._inner[0];
                    d = this.co.p._inner[0];
                }
                else {
                    c = this.co.d(a);
                    d = this.co.d(b);
                    if (b >= this.actualCount - this.de) {
                        d = this.co.c();
                    }
                }
            }
            else if (this.de > 0) {
                let e = new List$1(Number_$type, 0);
                for (let f = this.actualCount - this.de; f < this.actualCount; f++) {
                    e.add(f);
                }
                return e.toArray();
            }
            if (c == null || d == null) {
                return null;
            }
            if (c.q == this.c6 && c.l == this.c8 && c.r == this.c9 && c.p == this.c7 && c.t == this.db && c.s == this.da && d.q == this.cz && d.l == this.c1 && d.r == this.c2 && d.p == this.c0 && d.t == this.c4 && d.s == this.c3 && this.de == this.c5) {
                return this.ca;
            }
            this.c6 = c.q;
            this.cz = d.q;
            this.c8 = c.l;
            this.c1 = d.l;
            this.c9 = c.r;
            this.c2 = d.r;
            this.c7 = c.p;
            this.c0 = d.p;
            this.c4 = d.t;
            this.c3 = d.s;
            this.db = c.t;
            this.da = c.s;
            this.c5 = this.de;
            let g = new List$1(Number_$type, 0);
            for (let h = c.q; h <= d.q; h++) {
                let i = this.co.p._inner[h];
                let j = i.b.length;
                if (this.shouldEmitSectionHeaders && this.ah) {
                    for (let k = 0; k < i.b.length; k++) {
                        g.add(i.r + k);
                        if (!i.b[k]) {
                            break;
                        }
                    }
                }
                if (i.g) {
                    for (let l = 0; l < i.t; l++) {
                        g.add(i.r + l + j);
                    }
                    if (this.shouldEmitShiftedRows) {
                        for (let m = 0; m < i.l; m++) {
                            g.add(i.r + m + j);
                        }
                    }
                    for (let n = i.s - 1; n >= 0; n--) {
                        if (this.shouldEmitSectionFooters) {
                            g.add(i.p - j - n);
                        }
                        else {
                            g.add(i.p - n);
                        }
                    }
                }
                if (this.shouldEmitSectionFooters && this.ah) {
                    for (let o = i.b.length - 1; o >= 0; o--) {
                        if (!i.b[o]) {
                            break;
                        }
                        g.add(i.p - o);
                    }
                }
            }
            for (let p = this.actualCount - this.de; p < this.actualCount; p++) {
                g.add(p);
            }
            this.ca = g.toArray();
            return this.ca;
        }
        isExclusivelySticky(a) {
            return this.getRowType(a) == 1 || this.getRowType(a) == 2;
        }
        getRowType(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.rowType;
            }
            return 0;
        }
        getIsRowExpandedAtIndex(a) {
            let b = this.co.d(a);
            if (b == null) {
                b = this.co.c();
            }
            for (let c = 0; c < b.b.length; c++) {
                if (a == b.r + c) {
                    return b.b[c];
                }
            }
            return super.getIsRowExpandedAtIndex(a);
        }
        setIsRowExpandedAtIndex(a, b) {
            let c = this.co.d(a);
            if (c == null) {
                c = this.co.c();
            }
            for (let d = 0; d < c.b.length; d++) {
                if (a == c.r + d) {
                    let e = false;
                    let f = c.a[d];
                    if (this.cv.containsKey(f) && this.cv.item(f) != b) {
                        let g = this.cv.item(f);
                        if (b == this.isSectionExpandedDefault) {
                            this.cv.removeItem(f);
                        }
                        else {
                            this.cv.item(f, b);
                        }
                        e = true;
                        this.onRowExpansionChanged(a, g, b);
                    }
                    else if (b != this.isSectionExpandedDefault) {
                        this.cv.addItem(f, b);
                        e = true;
                        this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                    }
                    if (e) {
                        this.co.r();
                        this.d0();
                        this.cs = true;
                        if (this.actualCount != this.co.q) {
                            this.actualCount = this.co.q + this.de;
                        }
                        else {
                            this.queueAutoRefresh();
                        }
                    }
                    break;
                }
            }
        }
        getRowLevel(a) {
            if (a < 0) {
                return 0;
            }
            let b = this.getItemAtIndex(a);
            let item_ = b;
            if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
                return b.level;
            }
            if (this.sectionHeaderDisplayMode == 1) {
                return this.groupDescriptions.k.count;
            }
            else if (this.groupDescriptions.k.count > 0) {
                return 1;
            }
            return 0;
        }
        getRootSummaryRowCount() {
            return this.de;
        }
        dq(a) {
            let b = "";
            for (let c = 0; c < a.c.length; c++) {
                b += a.c[c] + ":" + a.d[c];
            }
            return b;
        }
        dr(a, b) {
            if (this.sectionHeaderDisplayMode == 0) {
                return this.dq(a);
            }
            let c = "";
            for (let d = 0; d < a.c.length; d++) {
                c += a.c[d] + ":" + a.d[d] + ":";
            }
            c += b;
            return c;
        }
        getRootSummaryResults() {
            return this.cc;
        }
        getSectionSummaryResults(a) {
            if (this.co.n && a >= 0 && a < this.co.p.count) {
                return this.co.p._inner[a].e;
            }
            return null;
        }
    }
    VirtualDataSource.$t = /*@__PURE__*/ markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
})();
//# sourceMappingURL=VirtualDataSource.js.map
