/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { BaseDataSource } from "./BaseDataSource";
import { Base, typeCast, Array_$type, Number_$type, markType } from "./type";
import { RearrangedListView } from "./RearrangedListView";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { List$1 } from "./List$1";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { DataSourceLocalDataProvider } from "./DataSourceLocalDataProvider";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { ISupportsDataChangeNotifications_$type } from "./ISupportsDataChangeNotifications";
import { ISupportsExpansionChangeNotifications_$type } from "./ISupportsExpansionChangeNotifications";
/**
 * @hidden
 */
var LocalDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(LocalDataSource, _super);
    function LocalDataSource() {
        var _this = _super.call(this) || this;
        _this.cb = null;
        _this.ca = null;
        _this.da = null;
        _this.cg = null;
        _this.ck = null;
        _this.cm = null;
        _this.ci = null;
        _this.cw = new List$1(Array_$type, 0);
        _this.cn = false;
        _this.b9 = null;
        _this.c4 = -1;
        _this.cx = -1;
        _this.c6 = -1;
        _this.cz = -1;
        _this.c7 = -1;
        _this.c0 = -1;
        _this.c5 = -1;
        _this.cy = -1;
        _this.c9 = -1;
        _this.c8 = -1;
        _this.c2 = -1;
        _this.c1 = -1;
        _this.c3 = -1;
        _this.executionContext = new DataSourceExecutionContext();
        return _this;
    }
    LocalDataSource.prototype.get_actualBaseDataProvider = function () {
        return this.actualDataProvider;
    };
    Object.defineProperty(LocalDataSource.prototype, "actualBaseDataProvider", {
        get: function () {
            return this.get_actualBaseDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "dataProvider", {
        get: function () {
            return this.cb;
        },
        set: function (a) {
            var b = this.cb;
            this.cb = a;
            if (b != this.cb) {
                this.onPropertyUpdated("DataProvider", b, this.cb);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "actualDataProvider", {
        get: function () {
            if (this.ca == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.ca;
        },
        set: function (a) {
            var b = this.ca;
            this.ca = a;
            if (b != this.ca) {
                this.onPropertyUpdated("ActualDataProvider", b, this.ca);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(LocalDataSource.prototype, "itemsSource", {
        get: function () {
            return this.da;
        },
        set: function (a) {
            var b = this.da;
            this.da = a;
            if (b != this.da) {
                this.onPropertyUpdated("ItemsSource", b, this.da);
            }
        },
        enumerable: true,
        configurable: true
    });
    LocalDataSource.prototype.canInitialize = function () {
        var a = _super.prototype.canInitialize.call(this);
        if (!a) {
            return false;
        }
        return this.itemsSource != null;
    };
    Object.defineProperty(LocalDataSource.prototype, "ch", {
        get: function () {
            return this.cg;
        },
        set: function (a) {
            this.cg = a;
            this.actualDataProvider = this.resolveDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    LocalDataSource.prototype.resolveDataProvider = function () {
        var provider_ = new DataSourceLocalDataProvider();
        provider_.executionContext = new DataSourceExecutionContext();
        return provider_;
    };
    LocalDataSource.prototype.propertyUpdatedOverride = function (a, b, c) {
        _super.prototype.propertyUpdatedOverride.call(this, a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                break;
            case "ActualDataProvider":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
            case "ItemsSource":
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.dataSource = this.itemsSource;
                    this.actualSchema = this.actualDataProvider.actualSchema;
                    this.actualCount = this.resolveFullCount(this.actualDataProvider.actualCount);
                }
                this.queueAutoRefresh();
                break;
        }
    };
    LocalDataSource.prototype.getItemAtIndex = function (a) {
        if (this.ck != null && this.ck.av != null) {
            return this.ck.av.item(a);
        }
        else {
            return this.actualDataProvider.getItemAtIndex(a);
        }
    };
    LocalDataSource.prototype.getItemPropertyAtIndex = function (a, b) {
        var c;
        if (this.ck != null) {
            c = this.ck.av.item(a);
        }
        else {
            c = this.actualDataProvider.getItemAtIndex(a);
        }
        var item_ = c;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return this.getSpecialRowItemValue(c, b);
        }
        return this.actualDataProvider.getItemValue(c, b);
    };
    LocalDataSource.prototype.cf = function () {
        return this.actualDataProvider;
    };
    LocalDataSource.prototype.cp = function () {
        return this.cw != null && this.cw.count > 0;
    };
    LocalDataSource.prototype.refreshInternalOverride = function () {
        _super.prototype.refreshInternalOverride.call(this);
        if (this.actualDataProvider != null) {
            if (this.cq() || this.cr() || this.cs() || this.ct() || this.cp()) {
                if (this.ck == null) {
                    if (this.cm == null) {
                        this.cm = new LocalDataSourceViewUpdateNotifier(this);
                    }
                    this.ck = new RearrangedListView(this.actualDataProvider);
                    this.ck.v = this.cm;
                    this.ck.x = new LocalDataSourceViewExpansionNotifier(this);
                }
                this.ensureComparables(this.actualDataProvider.actualSchema);
                this.ck.ak = this.shouldEmitSectionHeaders && this.ah;
                this.ck.aj = this.shouldEmitSectionFooters && this.ah;
                this.ck.al = this.shouldEmitShiftedRows;
                this.ck.bs(this.cw);
                this.ck.ar = this.cv();
                this.ck.aq = this.cu();
                this.ck.k = this.cj();
                this.ck.y = this.groupDescriptions;
                this.ck.z = this.sortDescriptions;
                this.ck.aa = this.summaryDescriptions;
                this.ck.g = this.summaryScope;
                this.ck.h = this;
                this.ck.ag = this.groupDescriptions != null && this.groupDescriptions.k.count > 0;
                this.ck.o = this.cl();
                this.ck.bo();
                this.actualSchema = this.actualDataProvider.actualSchema;
                this.actualCount = this.ck.av.count;
            }
            else {
                var a = this.cf();
                this.actualSchema = this.actualDataProvider.actualSchema;
                if (a != null) {
                    this.actualCount = a.actualCount;
                }
                else {
                    this.actualCount = 0;
                }
                if (this.ck != null) {
                    this.ck.v = null;
                    this.ck = null;
                    this.onBroadcastClearItems();
                }
            }
        }
        else {
            this.actualCount = 0;
            this.actualSchema = null;
        }
    };
    LocalDataSource.prototype.get_isItemIndexLookupSupported = function () {
        return true;
    };
    LocalDataSource.prototype.get_isKeyIndexLookupSupported = function () {
        return true;
    };
    LocalDataSource.prototype.indexOfItem = function (a) {
        if (this.ck != null) {
            return this.ck.av.indexOf(a);
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        if (this.actualDataProvider != null) {
            var b = this.actualDataProvider.actualCount;
            var c = void 0;
            for (var d = 0; d < b; d++) {
                c = this.actualDataProvider.getItemAtIndex(d);
                if (this.co(c, a)) {
                    return d;
                }
            }
        }
        return -1;
    };
    LocalDataSource.prototype.co = function (a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    };
    LocalDataSource.prototype.indexOfKey = function (a) {
        var b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return this.indexOfItem(a[0]);
        }
        var c = this.cj();
        var d;
        if (this.ck != null) {
            var e = this.ck.av.count;
            for (var f = 0; f < e; f++) {
                d = this.ck.av.item(f);
                if (!(typeCast(DataSourceSpecialRow.$, d) !== null) && c.i(d, a) == 0) {
                    return f;
                }
            }
            return -1;
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        if (this.actualDataProvider != null) {
            var g = this.actualDataProvider.actualCount;
            for (var h = 0; h < g; h++) {
                d = this.actualDataProvider.getItemAtIndex(h);
                if (c.i(d, a) == 0) {
                    return h;
                }
            }
        }
        return -1;
    };
    LocalDataSource.prototype.onActualPrimaryKeyChangedOverrride = function (a, b) {
        _super.prototype.onActualPrimaryKeyChangedOverrride.call(this, a, b);
        this.ci = null;
    };
    LocalDataSource.prototype.cj = function () {
        if (this.ci != null) {
            return this.ci;
        }
        if (this.actualPrimaryKey == null) {
            this.ci = new DataSourcePropertiesComparer(null, null, null, this);
            return this.ci;
        }
        var a = new Array(this.actualPrimaryKey.length);
        for (var b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        this.ci = new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.d, this);
        return this.ci;
    };
    LocalDataSource.prototype.cl = function () {
        if (this.filterExpressions.j.count == 0) {
            return null;
        }
        var a = this.actualDataProvider;
        var b = this.actualDataProvider.actualSchema;
        var c = this.filterExpressions.j;
        var d = function (e) {
            for (var f = 0; f < c.count; f++) {
                if (!c.item(f).match(e, a, b)) {
                    return false;
                }
            }
            return true;
        };
        return d;
    };
    LocalDataSource.prototype.cv = function () {
        var a = 0;
        if (this.sortDescriptions.k.count == 0 && (this.groupDescriptions == null || this.groupDescriptions.k.count == 0)) {
            return null;
        }
        a = this.sortDescriptions.k.count;
        if (this.groupDescriptions != null) {
            a += this.groupDescriptions.k.count;
        }
        var b = new Array(a);
        var c = new Array(a);
        var d = 0;
        if (this.groupDescriptions != null) {
            for (var e = 0; e < this.groupDescriptions.k.count; e++) {
                b[e] = this.groupDescriptions.k.item(e).propertyName;
                c[e] = this.groupDescriptions.k.item(e).direction;
                d++;
            }
        }
        for (var f = 0; f < this.sortDescriptions.k.count; f++) {
            b[f + d] = this.sortDescriptions.k.item(f).propertyName;
            c[f + d] = this.sortDescriptions.k.item(f).direction;
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    };
    LocalDataSource.prototype.cu = function () {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return null;
        }
        var a = 0;
        a = this.groupDescriptions.k.count;
        var b = new Array(a);
        var c = new Array(a);
        if (this.groupDescriptions != null) {
            for (var d = 0; d < this.groupDescriptions.k.count; d++) {
                b[d] = this.groupDescriptions.k.item(d).propertyName;
                c[d] = this.groupDescriptions.k.item(d).direction;
            }
        }
        return new DataSourcePropertiesComparer(b, c, this.d, this);
    };
    LocalDataSource.prototype.cr = function () {
        if (this.groupDescriptions == null || this.groupDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isGroupingSupported) {
            return false;
        }
        return true;
    };
    LocalDataSource.prototype.cs = function () {
        if (this.sortDescriptions == null || this.sortDescriptions.k.count < 1) {
            return false;
        }
        if (this.actualDataProvider == null) {
            return false;
        }
        if (this.actualDataProvider.isSortingSupported) {
            return false;
        }
        return true;
    };
    LocalDataSource.prototype.cq = function () {
        return this.filterExpressions != null && this.filterExpressions.j.count > 0;
    };
    LocalDataSource.prototype.ct = function () {
        if (this.summaryDescriptions == null || this.summaryDescriptions.k.count < 1) {
            return false;
        }
        return true;
    };
    LocalDataSource.prototype.onClearItemsOverride = function () {
        if (this.ck != null) {
            this.ck.notifyClearItems();
            this.queueAutoRefresh();
        }
        else {
            _super.prototype.onClearItemsOverride.call(this);
        }
    };
    LocalDataSource.prototype.onSetItemOverride = function (a, b, c) {
        if (this.ck != null) {
            this.ck.notifySetItem(a, b, c);
        }
        else {
            _super.prototype.onSetItemOverride.call(this, a, b, c);
        }
    };
    LocalDataSource.prototype.onInsertItemOverride = function (a, b) {
        if (this.ck != null) {
            this.ck.notifyInsertItem(a, b);
        }
        else {
            _super.prototype.onInsertItemOverride.call(this, a, b);
        }
    };
    LocalDataSource.prototype.onRemoveItemOverride = function (a, b) {
        if (this.ck != null) {
            this.ck.notifyRemoveItem(a, b);
        }
        else {
            _super.prototype.onRemoveItemOverride.call(this, a, b);
        }
    };
    LocalDataSource.prototype.df = function () {
        this.actualCount = this.ck.av.count;
        this.onBroadcastClearItems();
    };
    LocalDataSource.prototype.di = function (a, b, c) {
        this.actualCount = this.ck.av.count;
        this.onBroadcastSetItem(a, b, c);
    };
    LocalDataSource.prototype.dg = function (a, b) {
        this.actualCount = this.ck.av.count;
        this.onBroadcastInsertItem(a, b);
    };
    LocalDataSource.prototype.dh = function (a, b) {
        this.actualCount = this.ck.av.count;
        this.onBroadcastRemoveItem(a, b);
    };
    LocalDataSource.prototype.pinRow = function (a) {
        _super.prototype.pinRow.call(this, a);
        this.c4 = -1;
        this.cx = -1;
        if (this.ck != null) {
            this.cw.add(a);
            this.ck.bn(a);
        }
        else {
            this.cw.add(a);
            this.queueAutoRefresh();
        }
    };
    LocalDataSource.prototype.unpinRow = function (a) {
        _super.prototype.unpinRow.call(this, a);
        var b = this.cj();
        if (this.ck != null) {
            for (var c = this.cw.count - 1; c >= 0; c--) {
                var d = this.cw._inner[c];
                if (d.length != a.length) {
                    continue;
                }
                if (b.h(d, a) == 0) {
                    this.cw.removeAt(c);
                    this.ck.bu(d);
                }
            }
        }
        else {
            for (var e = this.cw.count - 1; e >= 0; e--) {
                var f = this.cw._inner[e];
                if (f.length != a.length) {
                    continue;
                }
                if (b.h(f, a) == 0) {
                    this.cw.removeAt(e);
                }
            }
            this.queueAutoRefresh();
        }
        this.c4 = -1;
        this.cx = -1;
    };
    LocalDataSource.prototype.clearPinnedRows = function () {
        for (var a = this.cw.count - 1; a >= 0; a--) {
            this.unpinRow(this.cw._inner[a]);
        }
    };
    LocalDataSource.prototype.isRowPinned = function (a) {
        if (this.ck == null) {
            return false;
        }
        var b = this.getItemAtIndex(a);
        if (b == null) {
            return false;
        }
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            if (item_.rowType == 3) {
                return true;
            }
        }
        var c = this.cj();
        var d;
        if (this.actualPrimaryKey == null) {
            d = new Array(1);
            d[0] = b;
        }
        else {
            var e = this.actualPrimaryKey;
            var f = e.length;
            d = new Array(f);
            for (var g = 0; g < f; g++) {
                d[g] = this.getItemProperty(b, e[g]);
            }
        }
        for (var h = 0; h < this.cw.count; h++) {
            if (c.h(this.cw._inner[h], d) == 0) {
                return true;
            }
        }
        return false;
    };
    LocalDataSource.prototype.get_isSortingSupported = function () {
        if (this.o != null && !this.cn) {
            this.cn = true;
            var a = this.o.isSortingSupportedOverride;
            this.cn = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.get_isFilteringSupported = function () {
        if (this.o != null && !this.cn) {
            this.cn = true;
            var a = this.o.isFilteringSupportedOverride;
            this.cn = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.get_isGroupingSupported = function () {
        if (this.o != null && !this.cn) {
            this.cn = true;
            var a = this.o.isGroupingSupportedOverride;
            this.cn = false;
            return a;
        }
        return true;
    };
    LocalDataSource.prototype.getStickyRowPriority = function (a) {
        var b = this.getRowType(a);
        switch (b) {
            case 1: return 100 - this.getRowLevel(a);
            case 2: return 99 - this.getRowLevel(a);
            case 3:
            case 5: return 2;
            case 4: return 3;
        }
        return 1;
    };
    LocalDataSource.prototype.getStickyRowsInRange = function (a, b) {
        if (this.ck == null || ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0) && !this.cp())) {
            return null;
        }
        var c = null;
        var d = null;
        if (this.ck.au.count == 1) {
            c = this.ck.au._inner[0];
            d = this.ck.au._inner[0];
        }
        else {
            c = this.ck.r(a);
            d = this.ck.r(b);
            if (b >= this.ck.av.count - this.ck.a6) {
                d = this.ck.q();
            }
        }
        if (c == null || d == null) {
            return null;
        }
        if (c.q == this.c4 && c.l == this.c6 && c.r == this.c7 && c.p == this.c5 && c.t == this.c9 && c.s == this.c8 && d.q == this.cx && d.l == this.cz && d.r == this.c0 && d.p == this.cy && d.t == this.c2 && d.s == this.c1 && this.ck.a6 == this.c3) {
            return this.b9;
        }
        this.c4 = c.q;
        this.cx = d.q;
        this.c6 = c.l;
        this.cz = d.l;
        this.c7 = c.r;
        this.c0 = d.r;
        this.c5 = c.p;
        this.cy = d.p;
        this.c3 = this.ck.a6;
        if (this.ck.au.count == 1) {
            this.cx = d.p;
        }
        var e = 0;
        if (this.shouldEmitSectionHeaders && this.ah) {
            e = 1;
        }
        var f = new List$1(Number_$type, 0);
        for (var g = c.q; g <= d.q; g++) {
            var h = this.ck.au._inner[g].b.length;
            if (this.shouldEmitSectionHeaders && this.ah) {
                for (var i = 0; i < h; i++) {
                    f.add(this.ck.au._inner[g].r + i);
                    if (!this.ck.au._inner[g].b[i]) {
                        break;
                    }
                }
            }
            if (this.ck.au._inner[g].g) {
                for (var j = 0; j < this.ck.au._inner[g].t; j++) {
                    f.add(this.ck.au._inner[g].r + j + h);
                }
                if (this.shouldEmitShiftedRows) {
                    for (var k = 0; k < this.ck.au._inner[g].l; k++) {
                        f.add(this.ck.au._inner[g].r + this.ck.au._inner[g].t + k + h);
                    }
                }
                for (var l = this.ck.au._inner[g].s - 1; l >= 0; l--) {
                    if (this.shouldEmitSectionFooters) {
                        f.add(this.ck.au._inner[g].p - h - l);
                    }
                    else {
                        f.add(this.ck.au._inner[g].p - l);
                    }
                }
            }
            if (this.shouldEmitSectionFooters && this.ah) {
                for (var m = h - 1; m >= 0; m--) {
                    if (!this.ck.au._inner[g].b[m]) {
                        break;
                    }
                    f.add(this.ck.au._inner[g].p - m);
                }
            }
        }
        for (var n = this.ck.av.count - this.ck.a6; n < this.ck.av.count; n++) {
            f.add(n);
        }
        this.b9 = f.toArray();
        return this.b9;
    };
    LocalDataSource.prototype.isExclusivelySticky = function (a) {
        var b = this.getRowType(a);
        return b == 1 || b == 2 || b == 4 || b == 5;
    };
    LocalDataSource.prototype.getRowType = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    };
    LocalDataSource.prototype.setIsRowExpandedAtIndex = function (a, b) {
        if (this.isSectionCollapsable && this.ck != null && this.ck.av.count > 0 && this.ck.av.count > a) {
            this.ck.br(a, b);
        }
    };
    LocalDataSource.prototype.getIsRowExpandedAtIndex = function (a) {
        if (this.ck != null && this.ck.av.count > 0 && this.ck.av.count > a) {
            return this.ck.ae(a);
        }
        return true;
    };
    LocalDataSource.prototype.getRowLevel = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        if (this.sectionHeaderDisplayMode == 1) {
            return this.groupDescriptions.k.count;
        }
        else if (this.groupDescriptions.k.count > 0) {
            return 1;
        }
        return 0;
    };
    LocalDataSource.prototype.getRootSummaryRowCount = function () {
        if (this.ck != null) {
            return this.ck.a6;
        }
        return 0;
    };
    LocalDataSource.prototype.getRootSummaryResults = function () {
        if (this.ck != null) {
            return this.ck.e;
        }
        return null;
    };
    LocalDataSource.prototype.getSectionSummaryResults = function (a) {
        if (this.ck != null && this.ck.au.count > 0 && a >= 0 && a < this.ck.au.count) {
            return this.ck.au._inner[a].e;
        }
        return null;
    };
    LocalDataSource.$t = markType(LocalDataSource, 'LocalDataSource', BaseDataSource.$);
    return LocalDataSource;
}(BaseDataSource));
export { LocalDataSource };
/**
 * @hidden
 */
var LocalDataSourceViewUpdateNotifier = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(LocalDataSourceViewUpdateNotifier, _super);
    function LocalDataSourceViewUpdateNotifier(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    LocalDataSourceViewUpdateNotifier.prototype.notifyClearItems = function () {
        this.a.df();
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifyInsertItem = function (a, b) {
        this.a.dg(a, b);
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifyRemoveItem = function (a, b) {
        this.a.dh(a, b);
    };
    LocalDataSourceViewUpdateNotifier.prototype.notifySetItem = function (a, b, c) {
        this.a.di(a, b, c);
    };
    LocalDataSourceViewUpdateNotifier.$t = markType(LocalDataSourceViewUpdateNotifier, 'LocalDataSourceViewUpdateNotifier', Base.$, [ISupportsDataChangeNotifications_$type]);
    return LocalDataSourceViewUpdateNotifier;
}(Base));
export { LocalDataSourceViewUpdateNotifier };
/**
 * @hidden
 */
var LocalDataSourceViewExpansionNotifier = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(LocalDataSourceViewExpansionNotifier, _super);
    function LocalDataSourceViewExpansionNotifier(a) {
        var _this = _super.call(this) || this;
        _this.a = null;
        _this.a = a;
        return _this;
    }
    LocalDataSourceViewExpansionNotifier.prototype.notifyRowExpansionChanged = function (a, b, c) {
        this.a.onRowExpansionChanged(a, b, c);
    };
    LocalDataSourceViewExpansionNotifier.$t = markType(LocalDataSourceViewExpansionNotifier, 'LocalDataSourceViewExpansionNotifier', Base.$, [ISupportsExpansionChangeNotifications_$type]);
    return LocalDataSourceViewExpansionNotifier;
}(Base));
export { LocalDataSourceViewExpansionNotifier };
//# sourceMappingURL=LocalDataSource_combined.js.map
