/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import * as tslib_1 from "tslib";
import { BaseDataSource } from "./BaseDataSource";
import { IPageCandidatesSink_$type } from "./IPageCandidatesSink";
import { PagePredictionEngine } from "./PagePredictionEngine";
import { LRUCache$2 } from "./LRUCache$2";
import { Base, runOn, Array_$type, Number_$type, typeCast, fromEnum, typeGetValue, String_$type, Boolean_$type, markType } from "./type";
import { IDataSourcePage_$type } from "./IDataSourcePage";
import { Dictionary$2 } from "./Dictionary$2";
import { SectionMap } from "./SectionMap";
import { DataSourceExecutionContext } from "./DataSourceExecutionContext";
import { SectionData } from "./SectionData";
import { List$1 } from "./List$1";
import { DataSourceSpecialRow } from "./DataSourceSpecialRow";
import { DataSourcePropertiesComparer } from "./DataSourcePropertiesComparer";
import { truncate, intDivide } from "./number";
/**
 * @hidden
 */
var VirtualDataSource = /** @class */ /*@__PURE__*/ (function (_super) {
    tslib_1.__extends(VirtualDataSource, _super);
    function VirtualDataSource() {
        var _this = _super.call(this) || this;
        _this.cb = null;
        _this.cs = false;
        _this.de = 0;
        _this.cm = null;
        _this.cf = null;
        _this.ce = null;
        _this.dd = 50;
        _this.dc = 200;
        _this.actualPageSizePopulated = false;
        _this.cy = 50;
        _this.cq = false;
        _this.cj = null;
        _this.cp = new LRUCache$2(Base.$, IDataSourcePage_$type, 0, 200);
        _this.cw = new Dictionary$2(Base.$, Array_$type, 0);
        _this.cx = new Dictionary$2(Number_$type, Number_$type, 0);
        _this.cr = false;
        _this.b9 = null;
        _this.cc = null;
        _this.co = new SectionMap();
        _this.ca = null;
        _this.c6 = -1;
        _this.cz = -1;
        _this.c8 = -1;
        _this.c1 = -1;
        _this.c9 = -1;
        _this.c2 = -1;
        _this.c7 = -1;
        _this.c0 = -1;
        _this.db = -1;
        _this.da = -1;
        _this.c4 = -1;
        _this.c3 = -1;
        _this.c5 = -1;
        _this.cv = new Dictionary$2(String_$type, Boolean_$type, 0);
        _this.cm = new PagePredictionEngine();
        _this.cm.e = _this;
        _this.cm.ag = _this.actualPageSize;
        _this.cm.f = _this.co;
        _this.executionContext = new DataSourceExecutionContext();
        _this.cm.b = _this.executionContext;
        return _this;
    }
    VirtualDataSource.prototype.get_actualBaseDataProvider = function () {
        return this.actualDataProvider;
    };
    Object.defineProperty(VirtualDataSource.prototype, "actualBaseDataProvider", {
        get: function () {
            return this.get_actualBaseDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "dataProvider", {
        get: function () {
            return this.cf;
        },
        set: function (a) {
            var b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.onPropertyUpdated("DataProvider", b, this.cf);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualDataProvider", {
        get: function () {
            if (this.ce == null) {
                this.actualDataProvider = this.resolveDataProvider();
            }
            return this.ce;
        },
        set: function (a) {
            var b = this.ce;
            this.ce = a;
            if (b != this.ce) {
                this.onPropertyUpdated("ActualDataProvider", b, this.ce);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "pageSizeRequested", {
        get: function () {
            return this.dd;
        },
        set: function (a) {
            var b = this.dd;
            this.dd = a;
            if (b != this.dd) {
                this.onPropertyUpdated("PageSizeRequested", b, this.dd);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resetCache = function () {
        if (this.ck != null) {
            this.ck.resetCache();
        }
        this.resetCacheOverride();
    };
    VirtualDataSource.prototype.resetCacheOverride = function () {
        this.cp.i();
    };
    Object.defineProperty(VirtualDataSource.prototype, "maxCachedPages", {
        get: function () {
            return this.dc;
        },
        set: function (a) {
            var b = this.dc;
            this.dc = a;
            if (b != this.dc) {
                this.onPropertyUpdated("MaxCachedPages", b, this.dc);
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(VirtualDataSource.prototype, "actualPageSize", {
        get: function () {
            return this.cy;
        },
        set: function (a) {
            var b = this.cy;
            this.cy = a;
            if (b != this.cy) {
                this.onPropertyUpdated("ActualPageSize", b, this.cy);
            }
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.get_isSortingSupported = function () {
        if (this.o != null && !this.cq) {
            this.cq = true;
            var a = this.o.isSortingSupportedOverride;
            this.cq = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isFilteringSupported = function () {
        if (this.o != null && !this.cq) {
            this.cq = true;
            var a = this.o.isFilteringSupportedOverride;
            this.cq = false;
            return a;
        }
        return false;
    };
    VirtualDataSource.prototype.get_isGroupingSupported = function () {
        if (this.o != null && !this.cq) {
            this.cq = true;
            var a = this.o.isGroupingSupportedOverride;
            this.cq = false;
            return a;
        }
        return false;
    };
    Object.defineProperty(VirtualDataSource.prototype, "ck", {
        get: function () {
            return this.cj;
        },
        set: function (a) {
            this.cj = a;
            this.actualDataProvider = this.resolveDataProvider();
        },
        enumerable: true,
        configurable: true
    });
    VirtualDataSource.prototype.resolveDataProvider = function () {
        if (this.ck == null) {
            return null;
        }
        return this.ck.resolveDataProvider();
    };
    VirtualDataSource.prototype.propertyUpdatedOverride = function (a, b, c) {
        _super.prototype.propertyUpdatedOverride.call(this, a, b, c);
        switch (a) {
            case "DataProvider":
                this.actualDataProvider = this.dataProvider;
                this.queueAutoRefresh();
                break;
            case "ExecutionContext":
                this.cm.b = this.executionContext;
                break;
            case "ActualDataProvider":
                this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                this.actualDataProvider.pageLoaded = runOn(this, this.dv);
                this.queueAutoRefresh();
                break;
            case "PageSizeRequested":
                this.actualPageSize = this.pageSizeRequested;
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.pageSizeRequested = this.pageSizeRequested;
                }
                this.queueAutoRefresh();
                break;
            case "ActualPageSize":
                this.cm.ag = this.actualPageSize;
                this.queueAutoRefresh();
                break;
            case "FirstVisibleIndexRequested":
                this.cm.aa = this.firstVisibleIndexRequested;
                break;
            case "LastVisibleIndexRequested":
                this.cm.ae = this.lastVisibleIndexRequested;
                break;
            case "ActualCount":
                if (this.actualDataProvider != null && !this.co.n) {
                    this.cm.ab = this.actualDataProvider.actualCount;
                }
                else {
                    this.cm.ab = this.actualCount;
                }
                this.queueAutoRefresh();
                break;
            case "MaxCachedPages":
                this.cp.h = this.maxCachedPages;
                break;
        }
    };
    VirtualDataSource.prototype.dh = function (a) {
        if (this.ah && this.co.n) {
            var b = this.cn(a);
            if (b == null) {
                b = this.co.c();
            }
            return a - b.i;
        }
        return a;
    };
    VirtualDataSource.prototype.dv = function (a, b, c) {
        var _this = this;
        var d = this.executionContext;
        if (d != null) {
            d.execute(function () { return _this.d1(a, b, c); });
        }
        else {
            this.d1(a, b, c);
        }
    };
    VirtualDataSource.prototype.d1 = function (a, b, c) {
        if (a == null) {
            b = this.resolveFullCount(b);
            if (this.actualCount != b) {
                this.actualCount = b;
            }
            return;
        }
        if (c != this.actualPageSize && !this.actualPageSizePopulated) {
            this.actualPageSize = c;
        }
        this.actualPageSizePopulated = true;
        var d = a.pageIndex();
        this.dw(d);
        this.cp.item(d, a);
        var e = a.schema();
        if (e != null) {
            this.actualSchema = e;
        }
        var f = a.getSummaryInformation();
        if (this.cc == null && f != null) {
            this.cc = f;
            for (var g = 0; g < this.summaryDescriptions.k.count; g++) {
                this.cc[g].summaryIndex = g;
            }
            var h = SectionData.h(this.cc);
            this.de = h.count;
        }
        var i = a.getGroupInformation();
        if (this.b9 == null && i != null) {
            this.b9 = i;
            this.d0();
            this.cs = false;
        }
        b = this.resolveFullCount(b);
        if (this.actualCount != b) {
            this.actualCount = b;
        }
        this.dz(a);
    };
    VirtualDataSource.prototype.resolveFullCount = function (a) {
        if (this.b9 != null) {
            return this.co.q + this.de;
        }
        return a + this.de;
    };
    VirtualDataSource.prototype.d0 = function () {
        var a = 0;
        var b = 0;
        var c = 0;
        if (this.shouldEmitSectionHeaders) {
            switch (this.sectionHeaderDisplayMode) {
                case 0:
                    c++;
                    break;
                case 1:
                    c += this.groupDescriptions.k.count;
                    break;
            }
        }
        if (this.shouldEmitSectionFooters) {
            c++;
        }
        var d = this.shouldEmitSectionHeaders;
        var e = this.shouldEmitSectionFooters;
        for (var f = 0; f < this.b9.length; f++) {
            var g = new SectionData();
            if (d) {
                switch (this.sectionHeaderDisplayMode) {
                    case 0:
                        b++;
                        break;
                    case 1:
                        b += this.groupDescriptions.k.count;
                        break;
                }
            }
            var h = this.b9[f].endIndex - this.b9[f].startIndex;
            g.r = a;
            g.q = f;
            g.o = h + 1;
            g.p = a + h;
            g.p += c;
            g.i = b;
            g.c = this.b9[f].groupKeyProperties;
            g.d = this.b9[f].groupKeyValues;
            g.u(this.sectionHeaderDisplayMode, this.isSectionExpandedDefault);
            if (e) {
                g.j = g.b.length;
            }
            var i = 0;
            g.e = this.b9[f].summaryResults;
            if (g.e != null) {
                for (var j = 0; j < g.e.length; j++) {
                    g.e[j].summaryIndex = j;
                }
                i = SectionData.h(g.e).count;
            }
            if (this.includeSummaryRowsInSection) {
                if (this.isSectionSummaryRowsAtBottom) {
                    g.s = i;
                }
                else {
                    g.t = i;
                    g.i += i;
                }
                b += i;
                g.p += i;
            }
            if (e) {
                b++;
            }
            for (var k = 0; k < g.b.length; k++) {
                var l = this.dr(g, k);
                g.a[k] = l;
                if (this.cv.containsKey(l)) {
                    g.b[k] = this.cv.item(l);
                }
                else {
                    g.b[k] = this.isSectionExpandedDefault;
                }
                if (!g.b[k]) {
                    var m = g.b.length - 1 - k;
                    g.p -= m;
                    b -= m;
                    if (e) {
                        b--;
                        g.j--;
                    }
                    k += m;
                }
            }
            if (!g.g) {
                g.p -= g.o + i;
                b -= g.o + i;
            }
            a = g.p + 1;
            this.co.p.add(g);
        }
    };
    VirtualDataSource.prototype.dz = function (a) {
        if (this.updateNotifier != null) {
            var b = a.pageIndex() * this.actualPageSize;
            if (this.actualDataProvider != null) {
                if (b > this.actualDataProvider.actualCount) {
                    return;
                }
            }
            var c = this.dg(b);
            var d = this.dg(b + a.count() - 1);
            if (c > 0 && this.getRowType(c - 1) == 1) {
                c--;
            }
            if (this.actualCount == 0 && a.count() == 0) {
                this.onClearItems();
            }
            else {
                this.updateNotifier.rangeActualized(c, d);
            }
        }
    };
    VirtualDataSource.prototype.dg = function (a) {
        if (this.ah && this.co.n) {
            var b = this.co.f(a);
            if (b == null) {
                b = this.co.c();
            }
            if (!b.g) {
                return b.r;
            }
            return a + b.i;
        }
        return a;
    };
    VirtualDataSource.prototype.dx = function (a) {
        a();
    };
    VirtualDataSource.prototype.get_isVirtual = function () {
        return true;
    };
    VirtualDataSource.prototype.isPlaceholderItem = function (a) {
        var b = this.cd(a);
        var c = b[0];
        if (!this.cp.d(c)) {
            if (b[1] == -1) {
                return false;
            }
            return true;
        }
        return false;
    };
    VirtualDataSource.prototype.getItemAtIndex = function (a) {
        if (a >= this.actualCount - this.de) {
            return this.dl(a);
        }
        var b = this.cd(a);
        var c = b[0];
        if (!this.cp.d(c)) {
            if (b[1] == -1) {
                return this.dl(a);
            }
            return null;
        }
        var d = this.cp.item(c);
        var e = b[1];
        if (e == -1) {
            return this.dl(a);
        }
        return d.getItemAtIndex(e);
    };
    VirtualDataSource.prototype.dl = function (a) {
        if (a >= this.actualCount - this.de) {
            var b = new DataSourceSpecialRow();
            b.rowType = 4;
            b.level = 0;
            var c = a - (this.actualCount - this.de);
            var d = SectionData.h(this.cc);
            var e = new Array(d._inner[c].count);
            d._inner[c].values.copyTo(e, 0);
            b.summaryResults = e;
            return b;
        }
        var f = this.cn(a);
        if (f != null) {
            var g = f.f(a);
            if (g == 1 || g == 2) {
                var h = new DataSourceSpecialRow();
                h.rowType = g;
                h.summaryResults = f.e;
                for (var i = 0; i < this.groupDescriptions.k.count; i++) {
                    h.setSectionValue(this.groupDescriptions.k.item(i).propertyName, f.d[i]);
                    h.setValue(this.groupDescriptions.k.item(i).propertyName, f.d[i]);
                }
                h.level = g == 1 ? a - f.r : (f.j - 1) - (a - (f.p - f.j + 1));
                return h;
            }
            else if (g == 5) {
                var j = new DataSourceSpecialRow();
                j.rowType = 5;
                j.level = f.b.length;
                var k = f.k(a);
                var l = SectionData.h(f.e);
                var m = new Array(l._inner[k].count);
                l._inner[k].values.copyTo(m, 0);
                j.summaryResults = m;
                return j;
            }
        }
        return null;
    };
    VirtualDataSource.prototype.cd = function (a) {
        if (this.ah && this.co.n) {
            var b = false;
            var c = this.cn(a);
            if (c == null) {
                c = this.co.c();
                if (this.cc.length > 0 && a > c.p) {
                    b = true;
                }
            }
            var d = c.r;
            if (a >= d && a < d + c.b.length && this.shouldEmitSectionHeaders) {
                b = true;
            }
            if (a - (d + c.b.length - 1) <= c.l + c.t) {
                b = true;
            }
            if (this.shouldEmitSectionFooters) {
                if (a <= c.p && a >= c.p - c.b.length - c.s) {
                    b = true;
                }
            }
            else if (c.s > 0) {
                if (a > c.p - c.s && a <= c.p) {
                    b = true;
                }
            }
            var e = a - c.i;
            var f = truncate(Math.floor(e / this.actualPageSize));
            var g = e % this.actualPageSize;
            if (b) {
                g = -1;
            }
            var h = new Array(2);
            h[0] = f;
            h[1] = g;
            return h;
        }
        else {
            var i = truncate(Math.floor(a / this.actualPageSize));
            var j = a % this.actualPageSize;
            var k = new Array(2);
            k[0] = i;
            k[1] = j;
            return k;
        }
    };
    VirtualDataSource.prototype.cn = function (a) {
        return this.co.d(a);
    };
    VirtualDataSource.prototype.getItemPropertyAtIndex = function (a, b) {
        if (a > (this.actualCount - 1) - this.de) {
            return this.dm(a, b);
        }
        var c = this.cd(a);
        var d = c[0];
        if (!this.cp.d(d)) {
            if (c[1] == -1) {
                return this.dm(a, b);
            }
            return null;
        }
        var e = this.cp.item(d);
        var f = c[1];
        if (f == -1) {
            return this.dm(a, b);
        }
        return e.getItemValueAtIndex(f, b);
    };
    VirtualDataSource.prototype.dm = function (a, b) {
        var c = this.dl(a);
        if (typeCast(DataSourceSpecialRow.$, c) !== null) {
            return c.getValue(b);
        }
        return null;
    };
    VirtualDataSource.prototype.dy = function (a) {
        if (!this.cx.containsKey(a)) {
            this.cx.addItem(a, 1);
        }
        else {
            this.cx.item(a, this.cx.item(a) + 1);
        }
    };
    VirtualDataSource.prototype.dw = function (a) {
        if (this.cx.containsKey(a)) {
            this.cx.item(a, this.cx.item(a) - 1);
            if (this.cx.item(a) <= 0) {
                this.cx.removeItem(a);
                if (this.actualDataProvider != null) {
                    this.actualDataProvider.removePageRequest(a);
                }
            }
        }
    };
    VirtualDataSource.prototype.addCandidate = function (a, b) {
        var c = false;
        if (!this.cw.containsKey(a)) {
            var d = new List$1(Number_$type, 0);
            var e = this.transformPage(a);
            for (var f = 0; f < e.length; f++) {
                var g = e[f];
                if (!this.cp.d(g)) {
                    d.add(g);
                    this.dy(g);
                    var h = this.cx.item(g);
                    if (h == 1 && this.actualDataProvider != null) {
                        this.actualDataProvider.addPageRequest(g, b);
                    }
                    c = true;
                }
            }
            if (d.count > 0) {
                this.cw.addItem(a, d.toArray());
            }
        }
        return c;
    };
    VirtualDataSource.prototype.removeCandidate = function (a) {
        if (this.cw.containsKey(a)) {
            for (var b = 0; b < this.cw.item(a).length; b++) {
                var c = this.cw.item(a)[b];
                this.dw(c);
            }
            this.cw.removeItem(a);
        }
    };
    VirtualDataSource.prototype.transformPage = function (a) {
        var b = [a];
        if (this.ah && this.co.n) {
            var c = a * this.actualPageSize;
            var d = c + this.actualPageSize - 1;
            var e = this.cn(c);
            var f = new List$1(Number_$type, 0);
            for (var g = c; g <= d; g++) {
                if (e == null) {
                    break;
                }
                if (g > e.p) {
                    if (e.q < this.co.p.count - 1) {
                        e = this.co.p._inner[e.q + 1];
                    }
                    else {
                        break;
                    }
                }
                if (!e.g || (g >= e.r && g <= e.r + (e.b.length - 1) + e.l)) {
                    continue;
                }
                var h = g - e.i;
                var i = intDivide(h, this.actualPageSize);
                if (!f.contains(i)) {
                    f.add(i);
                }
            }
            b = f.toArray();
        }
        return b;
    };
    VirtualDataSource.prototype.getUnrealizedCount = function () {
        var a = this.cp.g * this.actualPageSize;
        var b = this.actualCount - a;
        return b;
    };
    VirtualDataSource.prototype.onSetItemOverride = function (a, b, c) {
        _super.prototype.onSetItemOverride.call(this, a, b, c);
        var d = this.cd(a);
        var e = d[0];
        if (this.cp.d(e)) {
            this.cp.j(e);
        }
    };
    VirtualDataSource.prototype.refreshInternalOverride = function () {
        _super.prototype.refreshInternalOverride.call(this);
        this.actualPageSizePopulated = false;
        var a = this.actualCount != 0;
        this.cr = true;
        if (!this.cs) {
            this.resetCache();
            if (a) {
                this.onClearItems();
            }
            this.b9 = null;
            this.cc = null;
            this.de = 0;
            this.co.r();
        }
        else {
            this.cs = false;
            if (a) {
                this.onClearItems();
            }
        }
        this.d2();
        this.cm.au();
        this.cr = false;
    };
    VirtualDataSource.prototype.d2 = function () {
        var e_1, _a;
        if (this.actualDataProvider != null) {
            try {
                for (var _b = tslib_1.__values(fromEnum(this.cw.values)), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var a = _c.value;
                    for (var c = 0; c < a.length; c++) {
                        var b = a[c];
                        this.actualDataProvider.addPageRequest(b, 1);
                    }
                }
            }
            catch (e_1_1) {
                e_1 = { error: e_1_1 };
            }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return))
                        _a.call(_b);
                }
                finally {
                    if (e_1)
                        throw e_1.error;
                }
            }
        }
    };
    VirtualDataSource.prototype.onClearItemsOverride = function () {
        _super.prototype.onClearItemsOverride.call(this);
        if (!this.cr) {
            this.queueAutoRefresh();
        }
    };
    VirtualDataSource.prototype.onInsertItemOverride = function (a, b) {
        _super.prototype.onInsertItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.onRemoveItemOverride = function (a, b) {
        _super.prototype.onRemoveItemOverride.call(this, a, b);
        this.queueAutoRefresh();
    };
    VirtualDataSource.prototype.get_isItemIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.get_isKeyIndexLookupSupported = function () {
        return true;
    };
    VirtualDataSource.prototype.indexOfItem = function (a) {
        var b = this.cp.b;
        var c = b.o;
        var d = b.q;
        var e = d.count;
        var f = b.p;
        for (var g = 0; g < e; g++) {
            if (f._inner[g]) {
                continue;
            }
            var h = d._inner[g].b;
            var i = h.count();
            for (var j = 0; j < i; j++) {
                if (this.cu(h.getItemAtIndex(j), a)) {
                    var k = typeGetValue(c._inner[g]);
                    var l = k * this.actualPageSize;
                    return l + j;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isItemIndexLookupSupported) {
            return this.actualDataProvider.indexOfItem(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.cu = function (a, b) {
        if (a == null && b == null) {
            return true;
        }
        if (a == null || b == null) {
            return false;
        }
        return Base.equalsStatic(a, b);
    };
    VirtualDataSource.prototype.indexOfKey = function (a) {
        var b = this.actualPrimaryKey;
        if (b == null || b.length < 1 || this.actualBaseDataProvider == null) {
            return -1;
        }
        this.ensureComparables(this.actualSchema);
        var c = this.cl();
        var d = this.cp.b;
        var e = d.o;
        var f = d.q;
        var g = f.count;
        var h = d.p;
        for (var i = 0; i < g; i++) {
            if (h._inner[i]) {
                continue;
            }
            var j = f._inner[i].b;
            var k = j.count();
            for (var l = 0; l < k; l++) {
                if (c.i(j.getItemAtIndex(l), a) == 0) {
                    var m = typeGetValue(e._inner[i]);
                    var n = m * this.actualPageSize;
                    return n + l;
                }
            }
        }
        if (this.actualDataProvider != null && this.actualDataProvider.isKeyIndexLookupSupported) {
            return this.actualDataProvider.indexOfKey(a);
        }
        return -1;
    };
    VirtualDataSource.prototype.cl = function () {
        var a = new Array(this.actualPrimaryKey.length);
        for (var b = 0; b < a.length; b++) {
            a[b] = 0;
        }
        return new DataSourcePropertiesComparer(this.actualPrimaryKey, a, this.cb, this);
    };
    VirtualDataSource.prototype.getStickyRowPriority = function (a) {
        var b = this.getRowType(a);
        switch (b) {
            case 1: return 100 - this.getRowLevel(a);
            case 2: return 99 - this.getRowLevel(a);
            case 3:
            case 5: return 2;
            case 4: return 3;
        }
        return 1;
    };
    VirtualDataSource.prototype.unpinRow = function (a) {
        _super.prototype.unpinRow.call(this, a);
    };
    VirtualDataSource.prototype.pinRow = function (a) {
        _super.prototype.pinRow.call(this, a);
    };
    VirtualDataSource.prototype.isRowPinned = function (a) {
        return _super.prototype.isRowPinned.call(this, a);
    };
    VirtualDataSource.prototype.getStickyRowsInRange = function (a, b) {
        if ((this.groupDescriptions == null || this.groupDescriptions.k.count == 0) && (this.summaryDescriptions == null || this.summaryDescriptions.k.count == 0)) {
            return null;
        }
        var c = this.cn(a);
        var d = this.cn(b);
        if (this.co.p.count > 0) {
            if (this.co.p.count == 1) {
                c = this.co.p._inner[0];
                d = this.co.p._inner[0];
            }
            else {
                c = this.co.d(a);
                d = this.co.d(b);
                if (b >= this.actualCount - this.de) {
                    d = this.co.c();
                }
            }
        }
        else if (this.de > 0) {
            var e = new List$1(Number_$type, 0);
            for (var f = this.actualCount - this.de; f < this.actualCount; f++) {
                e.add(f);
            }
            return e.toArray();
        }
        if (c == null || d == null) {
            return null;
        }
        if (c.q == this.c6 && c.l == this.c8 && c.r == this.c9 && c.p == this.c7 && c.t == this.db && c.s == this.da && d.q == this.cz && d.l == this.c1 && d.r == this.c2 && d.p == this.c0 && d.t == this.c4 && d.s == this.c3 && this.de == this.c5) {
            return this.ca;
        }
        this.c6 = c.q;
        this.cz = d.q;
        this.c8 = c.l;
        this.c1 = d.l;
        this.c9 = c.r;
        this.c2 = d.r;
        this.c7 = c.p;
        this.c0 = d.p;
        this.c4 = d.t;
        this.c3 = d.s;
        this.db = c.t;
        this.da = c.s;
        this.c5 = this.de;
        var g = new List$1(Number_$type, 0);
        for (var h = c.q; h <= d.q; h++) {
            var i = this.co.p._inner[h];
            var j = i.b.length;
            if (this.shouldEmitSectionHeaders && this.ah) {
                for (var k = 0; k < i.b.length; k++) {
                    g.add(i.r + k);
                    if (!i.b[k]) {
                        break;
                    }
                }
            }
            if (i.g) {
                for (var l = 0; l < i.t; l++) {
                    g.add(i.r + l + j);
                }
                if (this.shouldEmitShiftedRows) {
                    for (var m = 0; m < i.l; m++) {
                        g.add(i.r + m + j);
                    }
                }
                for (var n = i.s - 1; n >= 0; n--) {
                    if (this.shouldEmitSectionFooters) {
                        g.add(i.p - j - n);
                    }
                    else {
                        g.add(i.p - n);
                    }
                }
            }
            if (this.shouldEmitSectionFooters && this.ah) {
                for (var o = i.b.length - 1; o >= 0; o--) {
                    if (!i.b[o]) {
                        break;
                    }
                    g.add(i.p - o);
                }
            }
        }
        for (var p = this.actualCount - this.de; p < this.actualCount; p++) {
            g.add(p);
        }
        this.ca = g.toArray();
        return this.ca;
    };
    VirtualDataSource.prototype.isExclusivelySticky = function (a) {
        return this.getRowType(a) == 1 || this.getRowType(a) == 2;
    };
    VirtualDataSource.prototype.getRowType = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.rowType;
        }
        return 0;
    };
    VirtualDataSource.prototype.getIsRowExpandedAtIndex = function (a) {
        var b = this.co.d(a);
        if (b == null) {
            b = this.co.c();
        }
        for (var c = 0; c < b.b.length; c++) {
            if (a == b.r + c) {
                return b.b[c];
            }
        }
        return _super.prototype.getIsRowExpandedAtIndex.call(this, a);
    };
    VirtualDataSource.prototype.setIsRowExpandedAtIndex = function (a, b) {
        var c = this.co.d(a);
        if (c == null) {
            c = this.co.c();
        }
        for (var d = 0; d < c.b.length; d++) {
            if (a == c.r + d) {
                var e = false;
                var f = c.a[d];
                if (this.cv.containsKey(f) && this.cv.item(f) != b) {
                    var g = this.cv.item(f);
                    if (b == this.isSectionExpandedDefault) {
                        this.cv.removeItem(f);
                    }
                    else {
                        this.cv.item(f, b);
                    }
                    e = true;
                    this.onRowExpansionChanged(a, g, b);
                }
                else if (b != this.isSectionExpandedDefault) {
                    this.cv.addItem(f, b);
                    e = true;
                    this.onRowExpansionChanged(a, this.isSectionExpandedDefault, b);
                }
                if (e) {
                    this.co.r();
                    this.d0();
                    this.cs = true;
                    if (this.actualCount != this.co.q) {
                        this.actualCount = this.co.q + this.de;
                    }
                    else {
                        this.queueAutoRefresh();
                    }
                }
                break;
            }
        }
    };
    VirtualDataSource.prototype.getRowLevel = function (a) {
        if (a < 0) {
            return 0;
        }
        var b = this.getItemAtIndex(a);
        var item_ = b;
        if ((item_ != null && item_.$$isSpecialRow !== undefined)) {
            return b.level;
        }
        if (this.sectionHeaderDisplayMode == 1) {
            return this.groupDescriptions.k.count;
        }
        else if (this.groupDescriptions.k.count > 0) {
            return 1;
        }
        return 0;
    };
    VirtualDataSource.prototype.getRootSummaryRowCount = function () {
        return this.de;
    };
    VirtualDataSource.prototype.dq = function (a) {
        var b = "";
        for (var c = 0; c < a.c.length; c++) {
            b += a.c[c] + ":" + a.d[c];
        }
        return b;
    };
    VirtualDataSource.prototype.dr = function (a, b) {
        if (this.sectionHeaderDisplayMode == 0) {
            return this.dq(a);
        }
        var c = "";
        for (var d = 0; d < a.c.length; d++) {
            c += a.c[d] + ":" + a.d[d] + ":";
        }
        c += b;
        return c;
    };
    VirtualDataSource.prototype.getRootSummaryResults = function () {
        return this.cc;
    };
    VirtualDataSource.prototype.getSectionSummaryResults = function (a) {
        if (this.co.n && a >= 0 && a < this.co.p.count) {
            return this.co.p._inner[a].e;
        }
        return null;
    };
    VirtualDataSource.$t = markType(VirtualDataSource, 'VirtualDataSource', BaseDataSource.$, [IPageCandidatesSink_$type]);
    return VirtualDataSource;
}(BaseDataSource));
export { VirtualDataSource };
//# sourceMappingURL=VirtualDataSource.js.map
